Subject: bug#61350: Eglot over Tramp freezes with large project

From: Thomas Koch <[email-masked]>
Date: Fri, 17 Feb 2023 12:33:49 +0200 (EET)

Thanks a lot Michael for the analysis.

I don't know anything about Emacs internals, but I have a healthy fear of threads and could understand that it might be a can of worms.

Maybe there are ideas that could be taken from JavaScript, which also has only a single thread. As I understand, any threading problem can be translated into event driven code. Additionally, browsers now support web workers which (in theory?) should avoid locks by not sharing context with the main thread:

https://developer.mozilla.org/en-US/docs/Web/API/Worker

I forwarded your analysis to the GitHub issue:
https://github.com/joaotavora/eglot/discussions/883#discussioncomment-5008509